#!/bin/bash

# $Id: nightkill.sh 4504 2005-09-27 12:48:47Z finnarne-guest $
# This script could be run every night, to kill stray processes. 

KEEPONES="root USER daemon"
USERLIMIT=10000

# New location for config file [pere 2004-04-25]
if [ -f /etc/skolelinux/nightkill.conf ] ; then 
  mv /etc/skolelinux/nightkill.conf /etc/debian-edu/nightkill.conf
fi

if [ -f /etc/debian-edu/nightkill.conf ] ; then 
  . /etc/debian-edu/nightkill.conf
fi 

for EVERY in $KEEPONES ; do 
  KEEP="${KEEP:+$KEEP|}^$EVERY"
done


ps hauxwn | \
  while read PUSER PID NULL ; do 
    [ $PUSER -ge $USERLIMIT ] && kill $PID >& /dev/null
  done

sleep 10
  
ps auxw  | \
  while read PUSER PID NULL ; do 
    [ $PUSER -ge $USERLIMIT ] && kill -9 $PID >& /dev/null 
  done
